// Coincides with 10.41
package main

import (
	migration "bitbucket.org/prmunty/util/dbmigration/db"
	"database/sql"
	_ "github.com/mattn/go-sqlite3"
	"log"
)

func main() {

	log.Println("starting...")
	const version float64 = 5.0

	log.Println(LanguageTableUpdate)

	migration.Migrate(version, func(tx *sql.Tx) (err error) {
		return migration.DoUntilErr(tx,
			LanguageTableUpdate,
		)

	})

}

func LanguageTableUpdate(tx *sql.Tx) error {
	log.Println("1...")
	return migration.DoUntilErr(tx,
		doLangUpdate,
	)

}

func doLangUpdate(tx *sql.Tx) (err error) {
	log.Println("2...")
	_, err = tx.Exec(`DROP TABLE IF EXISTS "languages"; CREATE TABLE "languages"(
	"language_id" Integer,
	"name" Text,
	"english" Text,
    "spanish" Text,
    "portuguese" Text);`)

	return err

}
