var remoteHB = null;

function hb () {
  var _hb = {
    host: {
      remote: null,
      local: null,
    },
    sock: null,
    isChanging: false
  };

  _hb.changeHost = changeHost;
  _hb.changeStart = changeStart;
  _hb.changeEnd = changeEnd;
  _hb.init = init;

  function getCookie(cname) {
    var name = cname + "=";
    var decodedCookie = decodeURIComponent(document.cookie);
    var ca = decodedCookie.split(';');
    for(var i = 0; i <ca.length; i++) {
        var c = ca[i];
        while (c.charAt(0) == ' ') {
            c = c.substring(1);
        }
        if (c.indexOf(name) == 0) {
            return c.substring(name.length, c.length);
        }
    }
    return "";
  }

  function setCookie(name, value) {
    document.cookie = name + "=" + value + ";path=/";
  }

  function changeHost(oIp, nIp) {
    oIp = oIp.match(/[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+/)[0];
    nIp = nIp.match(/[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+/)[0];

    if (oIp == _hb.host.local) {
      _hb.host.local = nIp;
      _hb.sock.onclose = null;

      init();
    }

    if (oIp == _hb.host.remote) {
      _hb.host.remote = nIp;

      setCookie('host-origin', nIp);
    }
  }

  function changeStart() {
    _hb.isChanging = true;
  }

  function changeEnd() {
    _hb.isChanging = false;
  }

  function init() {
    var cookie = getCookie('host-origin');
    var remote = null;

    if (cookie != '' && cookie != null && cookie != undefined) {
      remote = cookie;
    }

    _hb.host = {
      local: window.location.hostname,
      remote: remote
    };

    var sock = new WebSocket("ws://" + _hb.host.local + "/ws");

    sock.onclose = hbOnClose;

    function hbOnClose() {
      //Wait to see if we have a race condition
      setTimeout(hbTransition, 10000);

      function hbTransition() {
        if(!_hb.isChanging && _hb.host.remote) {
          $.ajax({
            url: 'http://' + _hb.host.remote + '/whoami',
            success: function() {
              $("#status-modal-title").text("Error");
              $("#status-modal-body").text("Something went wrong with the panel, navigating back to original panel");
              $("#status-modal").modal();
              $("#status-modal").one('hide.bs.modal', function() {
                  window.location = 'http://' + _hb.host.remote;
              });
            },
            error: function() {
              $("#status-modal-title").text("Error");
              $("#status-modal-body").text("Cannot reach panel or original panel, please notify an admin");
              $("#status-modal").modal();
            }
          });
        }
      }
    };

    _hb.sock = sock;
  }

  init();

  return _hb;
}

$(document).ready(function(ev) {
  remoteHB = new hb();
});
